.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ast.inc

.code

start:
invoke GetModuleHandle,NULL
mov	hInstance,eax
invoke InitCommonControls
invoke DialogBoxParam,hInstance,1000,NULL,addr DlgProc,NULL
invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg == WM_INITDIALOG
  
    .elseif uMsg == WM_COMMAND
    
        .if wParam == 1001
        	call HideIcons
        .elseif	 wParam == 1002
        	call ShowIcons 
        .endif         
          
	.elseif uMsg == WM_CLOSE 
	        EXIT:
		    invoke EndDialog,hWnd,0		             
  .endif
  xor eax, eax
  ret
DlgProc endp
GetDesktopListView  proc
    invoke  FindWindow, offset szProgman, NULL
    test    eax, eax
    jz      error
    invoke  FindWindowEx, eax, NULL, 0, NULL
  error:
    ret
GetDesktopListView  endp

ShowIcons       proc
    call    GetDesktopListView
    test    eax, eax
    jz      error
    push    eax
    invoke  IsWindowVisible, eax
    .if eax == 0
        mov     IconState, 0
    .else
        mov     IconState, 1
    .endif
    pop     eax
    cmp     IconState, 1
    je      error
    invoke  ShowWindow, eax, SW_SHOW
    mov     IconState, 1
  error:
    ret
ShowIcons       endp

HideIcons       proc
    call    GetDesktopListView
    test    eax, eax
    jz      error
    push    eax
    invoke  IsWindowVisible, eax
    .if eax == 0
        mov     IconState, 0
    .else
        mov     IconState, 1
    .endif
    pop     eax
    cmp     IconState, 0
    je      error
    invoke  ShowWindow, eax, SW_HIDE
    mov     IconState, 0
  error:
    ret
HideIcons       endp

end start
